﻿Type=StaticCode
Version=4.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@

Sub Process_Globals
	Private fx As JFX
	Public SQL1 As SQL	
	Public DBaseFilePath As String
	Public ExcelFilePath As String
End Sub

Public Sub CreateSqlDatabase
	SetFilePath
	
	SQL1.InitializeSQLite(File.DirApp, "data/qtab.db", True)	' ditto

End Sub

Private Sub SetFilePath
	' DBase File Path
	If Not(File.IsDirectory(File.DirApp, "data")) Then
		File.MakeDir(File.DirApp, "data")
		DBaseFilePath = File.Combine(File.DirApp, "data")
	Else
		DBaseFilePath = File.Combine(File.DirApp, "data")		
	End If
	
	' Excel File Path
	If Not(File.IsDirectory(File.DirApp, "excel")) Then
		File.MakeDir(File.DirApp, "excel")
		ExcelFilePath = File.Combine(File.DirApp, "excel")
	Else
		ExcelFilePath = File.Combine(File.DirApp, "excel")		
	End If	
End Sub


Public Sub CreateRacingTables
	
'	DBUtils.DropTable(SQL1, "MeetDay")
	CreateMeetDay
'	DBUtils.DropTable(SQL1, "MeetRace")
	CreateMeetRace
'	DBUtils.DropTable(SQL1, "MeetDisplay")
	CreateMeetDisplay
End Sub

#Region Internet Download of Meetings - Purely used to download data to be imported into the program databases
' Internet - Obtain UniTab Info for a date - RaceDay.xml
' Meeting Module
' Meeting Date Database
Public Sub CreateMeetDay
	Dim M As Map
	
	M.Initialize
	M.Put("QMId", DBUtils.DB_INTEGER)			' + auto inc
	M.Put("MonthLong", DBUtils.DB_TEXT)			' used in Meeting Label
	M.Put("RaceDayDate", DBUtils.DB_TEXT)		
	M.Put("DayOfTheWeek", DBUtils.DB_TEXT)		' used in Meeting Label
	M.Put("BigDate", DBUtils.DB_TEXT)			' used to link other records for Meeting Date	
	M.Put("Day", DBUtils.DB_TEXT)				' used in Meeting Label
	M.Put("Month", DBUtils.DB_TEXT)
	M.Put("Year", DBUtils.DB_TEXT)				' used in Meeting Label
	
	DBUtils.CreateTable(SQL1, "MeetDay", M, "QMId")
End Sub

' Internet - Obtain UniTab Info for a date - RaceDay.xml
' Meeting Module
' A Race at a Venue for a Meeting Day (above) - e.g.: Flemington, Race 1
' Displays in a TableView in Meeting Module when Downloading
Public Sub CreateMeetRace
	Dim M As Map
	
	M.Initialize
	M.Put("RId", DBUtils.DB_INTEGER)				' + auto inc
	M.Put("QMId", DBUtils.DB_INTEGER)				' foreign key to MeetDay
	M.Put("VenueName", DBUtils.DB_TEXT)		
	M.Put("MeetingCode", DBUtils.DB_TEXT)
	M.Put("RaceNo", DBUtils.DB_TEXT)
	M.Put("MeetingType", DBUtils.DB_TEXT)		
	M.Put("RaceName", DBUtils.DB_TEXT)
	M.Put("RaceTime", DBUtils.DB_TEXT)
	M.Put("RaceDisplayStatus", DBUtils.DB_TEXT)

	DBUtils.CreateTable(SQL1, "MeetRace", M, "RId")
End Sub

' Internet - Obtain UniTab Info for a date - RaceDay.xml
' Meeting Module
' List of Venues for a Meeting date
' Popup window used for Import of Race Meetings in the Race Module
Public Sub CreateMeetDisplay
	Dim M As Map
	
	M.Initialize
	M.Put("DId", DBUtils.DB_INTEGER)			' + auto inc
	M.Put("BigDate", DBUtils.DB_TEXT)			' foreign key
	M.Put("VenueName", DBUtils.DB_TEXT)		
	M.Put("MeetingCode", DBUtils.DB_TEXT)
	M.Put("NextRaceNo", DBUtils.DB_TEXT)
	M.Put("HiRaceNo", DBUtils.DB_TEXT)		
	M.Put("Abandoned", DBUtils.DB_TEXT)
	
	DBUtils.CreateTable(SQL1, "MeetDisplay", M, "DId")
End Sub
#End Region

