﻿Type=Class
Version=4.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private frm As Form
	Private DayEd As TextField
	Private MonthEd As TextField
	Private YearEd As TextField
	Private ObtainRaceMeetBtn As Button
	Private MeetDayTV As TableView	
	Private MeetDayPnl As Pane
	Private MeetDetailsLbl As Label
	
	Dim MeetMap As Map
	Dim RaceMap As Map
	Dim DisplayMap As Map
	Dim RaceList As List
	Dim DisplayList As List
	
	Private BaseUrl As String
	Private TheUrl As String
	Private MyFile As String
	Private Msgbox As Msgboxes

	' parser vars
	Private parser As SaxParser
	Private MeetingCode, VenueName, MeetingType, LowRaceNo As String
	Private aBigDate As String
	Dim xQMid As Int
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Parent As Form)
	frm.Initialize("frm", 600, 600)
	frm.RootPane.LoadLayout("MeetsFrm")
	frm.SetOwner(Parent)

	Setups
	SetupTableView
End Sub

Public Sub Show
	frm.Title = "Today's Meetings available from the TAB"
	RaceList.Initialize			' List
	DisplayList.Initialize		' List
	
	ObtainRaceMeetBtn.RequestFocus
	
	frm.ShowAndWait
End Sub

Private Sub frm_Resize(Width As Double, Height As Double)
	frm.SetWindowSizeLimits(frm.WindowWidth, 450.0, frm.WindowWidth, 800.0)	
End Sub

Private Sub Setups
	YearEd.Text = DateTime.GetYear(DateTime.Now)
	MonthEd.Text = DateTime.GetMonth(DateTime.Now)
	DayEd.Text = DateTime.GetDayOfMonth(DateTime.Now)
	BaseUrl = "http://tatts.com/pagedata/racing/"

	parser.Initialize
'	DateTime.TimeFormat = "hh:mm:ss aa"

End Sub

Sub ObtainRaceMeetBtn_Action
	Dim IsOk As Boolean
	
	Log ($"1 - Start - $Time{DateTime.Now}"$)
	RaceList.Clear
	
	Log ($"1 - Call WorkUrl - $Time{DateTime.Now}"$)
	IsOk = WorkUrl
	
	frm.RootPane.MouseCursor = fx.Cursors.WAIT
	
	If IsOk Then 
		DownloadRace
	End If
	
	Log($"Exit Sub ObtainRaceMeetBtn_Action - $Time{DateTime.Now}"$)

End Sub

Private Sub DownloadRace
	Dim job1 As HttpJob                       	        ' HTTP job for download
	Dim fileLocal As String = MyFile	   		      	' Local filename; also used as job name
	Dim fileURL As String = TheUrl				      	' Remote filename

	Log ($"2 - DownloadRace - $Time{DateTime.Now}"$)
	
	job1.Initialize(fileLocal, Me)                      ' Init the job using fileLocal as Jobname
	job1.Download(fileURL)
	
	Log($"Exit Sub DownloadRace - $Time{DateTime.Now}"$)
	' Use JobDone Event to action result --- see below
End Sub

' Download from Internet job done task
' The jobname is used as the filename to store the local in the app folder (same as the jar file)
Private Sub JobDone (Job As HttpJob)
	Log("Job result for JobName = " & Job.JobName & ", Success = " & Job.Success)
	' Job done ok, lets save the content to the local file
	
	Log ($"2 - JobDone - $Time{DateTime.Now}"$)
	
	If Job.Success = True Then                          
	    Try
			' Creates an output file and assigns it to the out var
			Dim out As OutputStream = File.OpenOutput(File.DirApp, Job.JobName, False)
			' copies the input stream to the output 'out' which is a file
			File.Copy2(Job.GetInputStream, out)
			' close the out stream
			out.Close
			Log($"3a - Job Done. Local file created: ${Job.JobName} - (${File.DirApp} - $Time{DateTime.Now})"$)

			parseXMLFile		' parse the file
	    Catch
			Log($"Job Error. Can not create local file: ${LastException.Message} - $Time{DateTime.Now}"$)
	    End Try
	Else
		Log($"Job Error: ${Job.ErrorMessage} - $Time{DateTime.Now}"$)
		frm.RootPane.MouseCursor = fx.Cursors.DEFAULT	
		
		fx.Msgbox(frm, "Download of File failed - " & Job.ErrorMessage, "Connect Error")		
	End If
	Job.Release 
	Log($"Exit Sub JobDone - $Time{DateTime.Now}"$)
End Sub

Private Sub parseXMLFile
	' Define the xml file to parse.
	
	Log ($"4 - parseXMLFile - $Time{DateTime.Now}"$)
	
	Dim xmlFile As String = "RaceDay.xml"  ' MyFile
'	Dim xmlFile As String = MyFile
	If File.Exists(File.DirApp, xmlFile) = False Then
		Log("Error: XML file to parse not found.")
		Return
	End If
	' Clear all nodes from the listview
	If RaceList.IsInitialized Then
		RaceList.Clear
	End If
	'parse the xml file
	Dim In As InputStream
	Try
		
		Log ($"5 - Setup InputStream - $Time{DateTime.Now}"$)
		
		LowRaceNo = 24
		In = File.OpenInput(File.DirApp, xmlFile)
		
		Log ($"6 - Call parser.Parse - $Time{DateTime.Now}"$)
		
		parser.Parse(In, "Parser")
		In.Close
		Log($"Information: Imported Races from XML File: ${xmlFile}"$)
		
		' We can delete the file after it is parssed
		File.Delete(File.DirApp, xmlFile)		
	Catch
		Log($"Error: XML Import:  ${LastException.Message}"$)		
	End Try  
	
	Log($"Exit Sub parseXMLFile  - $Time{DateTime.Now}"$)

End Sub


Private Sub Parser_StartElement (Uri As String, Name As String, Attributes As Attributes)
	Dim idx As Int
	Dim str1, nextraceno As String
	
	Log ($"7 - StartElement begin - $Time{DateTime.Now}"$)
	
	If Name = "RaceDay" Then
		Dim monthlong, dayofweek, days, months, years, str1 As String
		Dim bigdates As String
		
		Dim MeetMap As Map
		MeetMap.Initialize
		
		monthlong = Attributes.GetValue2("", "MonthLong")			' April
		dayofweek = Attributes.GetValue2("", "DayOfTheWeek")		' Saturday
		days =  Attributes.GetValue2("", "Day")						' 6
		months = Attributes.GetValue2("", "Month")					' 5
		years = Attributes.GetValue2("", "Year")					' 2014
		' make bigdate
		bigdates = years
		If months.Length = 1 Then
			bigdates = bigdates & "0" & months
		Else
			bigdates = bigdates & months
		End If
		If days.Length = 1 Then
			bigdates = bigdates & "0" & days
		Else
			bigdates = bigdates & days
		End If
		aBigDate = bigdates
		MeetMap.Put("QMId", Null)
		MeetMap.Put("MonthLong", monthlong)
		MeetMap.Put("RaceDayDate", days & "-" & months & "-" & years)
		MeetMap.Put("DayOfTheWeek", dayofweek)
		MeetMap.Put("BigDate", bigdates)
		MeetMap.Put("Day", days)
		MeetMap.Put("Month", months)
		MeetMap.Put("Year", years)
	Else If Name = "Meeting" Then
		MeetingCode = Attributes.GetValue2("", "MeetingCode")
		VenueName = Attributes.GetValue2("", "VenueName")
		MeetingType = Attributes.GetValue2("", "MeetingType")
		Dim DisplayMap As Map 
		DisplayMap.Initialize
		DisplayMap.Put("DId", Null)
		DisplayMap.Put("BigDate", aBigDate)
		DisplayMap.Put("VenueName", Attributes.GetValue2("", "VenueName"))
		DisplayMap.Put("MeetingCode", Attributes.GetValue2("", "MeetingCode"))
		DisplayMap.Put("NextRaceNo", Attributes.GetValue2("", "NextRaceNo"))
		DisplayMap.Put("HiRaceNo", Attributes.GetValue2("", "HiRaceNo"))
		DisplayMap.Put("Abandoned", Attributes.GetValue2("", "Abandoned"))
	Else If parser.Parents.IndexOf("Meeting") > -1 Then
		If Name = "Race" Then
			Dim RaceMap As Map
			RaceMap.Initialize
			RaceMap.Put("RId", Null)
			RaceMap.Put("QMId", 0)
			RaceMap.Put("MeetingCode", MeetingCode)
			RaceMap.Put("VenueName", VenueName)
			RaceMap.Put("MeetingType", MeetingType)
			nextraceno =  Attributes.GetValue2("", "RaceNo")
			RaceMap.Put("RaceNo", Attributes.GetValue2("", "RaceNo"))
			RaceMap.Put("RaceName", Attributes.GetValue2("", "RaceName"))
			str1 = Attributes.GetValue2("", "RaceTime")
			idx = str1.IndexOf("T")
			str1 = str1.SubString(idx+1)
			idx = str1.LastIndexOf(":")
			str1 = str1.SubString2(0, idx)
			RaceMap.Put("RaceTime", str1)
			RaceMap.Put("RaceDisplayStatus", Attributes.GetValue2("", "RaceDisplayStatus"))
			If nextraceno < LowRaceNo Then LowRaceNo = nextraceno
		End If
	End If
End Sub

Private Sub Parser_EndElement (Uri As String, Name As String, Text As StringBuilder)
'	Save Race to RaceList at end of Race
	If Name = "Race" Then
		If MeetingType = "R" Then
			RaceList.Add(RaceMap)
		End If
	End If
	If Name = "Meeting" Then
		If MeetingType = "R" Then
			If DisplayMap.Get("NextRaceNo") <> "1" Then DisplayMap.Put("NextRaceNo", LowRaceNo)
			DisplayList.Add(DisplayMap)
		End If
	End If
	If Name = "RaceDay" Then
		
		Log ($"8 - Finish Parse - call SaveToMeetDbase - $Time{DateTime.Now}"$)
		
		' Save the RaceList to Database
		' Save the HorseList to Database
		CallSubDelayed(Me,"SaveToMeetDbase")
	End If
	
	Log($"Exit Sub Parser_EndElement - $Time{DateTime.Now}"$)
End Sub

' Following Five subs are used from Sub SaveToMeetDbase
Private Sub ShowDisplayPanel
	Dim str1 As String
	' Put MeetDay Details into Display Panel label
	str1 = "Meetings for " &  MeetMap.Get("DayOfTheWeek") & ", " & MeetMap.Get("MonthLong") & " " & MeetMap.Get("Day")
	str1 = str1 & ", " & MeetMap.Get("Year") 
	MeetDetailsLbl.Text = str1	
End Sub

' ADD this meeting day to MeetDay database
private Sub AddToMeetDte
	Dim rdate As String
	Dim Qry1, Qry2 As String
	Dim m, m1 As Map

	' Check for MeetDate  or use 'aBigDate'
	rdate = MeetMap.Get("BigDate")
	
	Qry1 = "SELECT * FROM MeetDay WHERE [BigDate] = '" & rdate & "'"
	m = DBUtils.ExecuteMap(DM.SQL1, Qry1, Null)
	If m.IsInitialized Then
		' we have this meet already
		xQMid = m.Get("qmid")
	Else
		' we do NOT have this meet day in the MeetDay database...
		
		' ADD this meeting day to MeetDay database
		DBUtils.InsertMaps(DM.SQL1, "MeetDay", Array As Object(MeetMap))
		' get QMId from this MeetDay
		Qry2 = "SELECT last_insert_rowid() as ID FROM MeetDay"
		m1 = DBUtils.ExecuteMap(DM.SQL1, Qry2, Null)
		If m1.IsInitialized Then
			xQMid = m1.Get("id")
		Else
			' failed to get Last ID
			Log("No QMID as Meeting not in MeetDay Dbase")
			Return
		End If
	End If	
End Sub

Private Sub AddQMidToRaceList
	Dim RaceCount As Int
	' add the QMId to the races in the maps in each race in the RaceList
	RaceCount = RaceList.Size
	If RaceCount > 0 Then
		For i = 0 To RaceCount-1
			Dim fm As Map
			fm.Initialize
			fm = RaceList.Get(i)
			fm.Put("QMId", xQMid)
		Next
	Else 
		Log("No Horses in this HorseList")
		Return
	End If
End Sub

Private Sub SaveUpdateRaceList
	Dim RaceCount As Int
	Dim Qry1, Qry2 As String
	Dim RId As Int
	Dim m2, m3 As Map
			
	RaceCount = RaceList.Size
	' Save or Update the RaceList to Database
	For i = 0 To RaceCount-1
		Dim fm As Map
		fm.Initialize
		fm = RaceList.Get(i)
		Qry1 = "SELECT * FROM MeetRace WHERE QMId = " & xQMid & " and [MeetingCode] = '" & fm.Get("MeetingCode")
		Qry1 = Qry1 & "' and [RaceNo] = '" & fm.Get("RaceNo") & "'"
		m2 = DBUtils.ExecuteMap(DM.SQL1, Qry1, Null)
		If m2.IsInitialized Then
			' UPDATE EXISTING RACE
			Log("Race Day exists")
			' remove the rid so it is not part of the update from the fm map
			RId = m2.Get("rid")
			fm.Remove("RId")
			Dim WhereField As Map
			WhereField.Initialize
			WhereField.Put("RId", RId)
			DBUtils.UpdateRecord2(DM.SQL1, "MeetRace", fm, WhereField)
		Else
			' SAVE NEW RACE
			DBUtils.InsertMaps(DM.SQL1, "MeetRace", Array As Object(fm))	
			' we need a RId from the New Race to use in the Horses
			Qry2 = "SELECT last_insert_rowid() as ID FROM MeetRace"
			m3 = DBUtils.ExecuteMap(DM.SQL1, Qry2, Null)
			If m3.IsInitialized Then
				RId = m3.Get("id")
			Else
				' failed to get Last ID
				RId = 0
				Log("RId not found from new race..")
				Return
			End If
			
		End If
		' show in TableView
		AddRaceTableView("MeetRace", RId)
	Next	
	
	RaceList.Clear	
	
End Sub

Private Sub AddToMeetDisplay
	Dim Qry1 As String
	Dim DId As Int
	Dim cnt As Int
	Dim md As Map	
	' put in the MeetDisplay
	cnt = DisplayList.Size
	For i = 0 To cnt - 1
		Dim tdm As Map
		tdm.Initialize
		tdm = DisplayList.Get(i)
		Qry1 = "SELECT * FROM MeetDisplay WHERE [BigDate] = '" & tdm.Get("BigDate") & "' and [MeetingCode] = '" & tdm.Get("MeetingCode") & "'"
		md = DBUtils.ExecuteMap(DM.SQL1, Qry1, Null)
		If md.IsInitialized Then
			' UPDATE EXISTING Display
			Log("Race Display exists")
			DId = md.Get("did")
			tdm.Remove("DId")
			Dim WhereField As Map
			WhereField.Initialize
			WhereField.Put("DId", DId)
			DBUtils.UpdateRecord2(DM.SQL1, "MeetDisplay", tdm, WhereField)
		Else	
			' ADD this meeting Track to MeetDisplay database
			DBUtils.InsertMaps(DM.SQL1, "MeetDisplay", Array As Object(tdm))	
		End If
	Next	
	
	DisplayList.Clear
	
End Sub

' Five subs above used to do the following work
Private Sub SaveToMeetDbase

	Log ($"2 - Call ShowDisplayPanel - $Time{DateTime.Now}"$)
	ShowDisplayPanel
	
	Log ($"2 - Call AddToMeetDte - $Time{DateTime.Now}"$)
	AddToMeetDte
	
	Log ($"2 - Call AddQMidToRaceList - $Time{DateTime.Now}"$)
	AddQMidToRaceList
	
	Log ($"12 - Call SaveUpdateRaceList - $Time{DateTime.Now}"$)
	SaveUpdateRaceList
	
	Log ($"13 - Call AddToMeetDisplay - $Time{DateTime.Now}"$)
	AddToMeetDisplay

	frm.RootPane.MouseCursor = fx.Cursors.DEFAULT	
	
	Log($"Exit Sub SaveToMeetDbase - $Time{DateTime.Now}"$)
End Sub

Private Sub WorkUrl As Boolean
	Dim str1 As String
	Dim message, title As String
	' base URL
	TheUrl = BaseUrl
	
	' year
	str1 = YearEd.Text
	If str1.Length < 4 Then
		message = "Year must be entered! e.g.: 2014"
		title = "Data Entry Error"
		Msgbox.DialogType = "ERROR"
		Msgbox.Show(message, title)
		Return False
	Else
		TheUrl = TheUrl & str1
	End If
	TheUrl = TheUrl & "/"
	
	' Month
	str1 = MonthEd.Text
	If str1.Length < 1 Then
		message = "Month must be entered!"
		title = "Data Entry Error"
		Msgbox.DialogType = "ERROR"
		Msgbox.Show(message, title)
		Return False
	Else
		TheUrl = TheUrl & str1	
	End If
	TheUrl = TheUrl & "/"
	
	' Day
	str1 = DayEd.Text
	If str1.Length < 1 Then
		message = "Day must be entered!"
		title = "Data Entry Error"
		Msgbox.DialogType = "ERROR"
		Msgbox.Show(message, title)
		Return False
	Else
		TheUrl = TheUrl & str1	
	End If
	
	TheUrl = TheUrl & "/RaceDay.xml"
		
	MyFile = "RaceDay.xml"
	
	Return True
End Sub

Private Sub AddRaceTableView(racetable As String, RId As Int)
	Dim Qry1 As String
	
	Qry1 = "SELECT VenueName, MeetingCode, RaceNo, RaceName, RaceTime, RaceDisplayStatus FROM MeetRace"
	Qry1 = Qry1 & " WHERE RId = " & RId

	DBUtils.LoadTVMeetings(DM.SQL1, Qry1, Null, 0, MeetDayTV, 0)
End Sub

' looks for data for the date in the edit controls and loads it into tableview
Sub ShowDateBtn_Action
	Dim str1, Qry1, Qry2, BigDte As String
	Dim message, title As String
	Dim aQMid As Int
	
	MeetDayTV.Items.Clear
	
	' get Big Date to cheeck Meeting DBase for this Meeting being available
	' year
	str1 = YearEd.Text
	If str1.Length <> 4 Then
		message = "Year must be entered as Four Digits! e.g.: 2014"
		title = "Data Entry Error"
		Msgbox.DialogType = "ERROR"
		Msgbox.Show(message, title)
		YearEd.RequestFocus
		Return
	Else
		BigDte = str1
	End If
	
	' Month
	str1 = MonthEd.Text
	If str1.Length < 1 Then
		message = "Month must be entered!"
		title = "Data Entry Error"
		Msgbox.DialogType = "ERROR"
		Msgbox.Show(message, title)
		MonthEd.RequestFocus
		Return
	Else
		If str1.Length = 1 Then
			BigDte = BigDte & "0" & str1
		Else
			If str1.Length = 2 Then 
				BigDte = BigDte & str1
			Else
				message = "Month must be two digits e.g.: 01, 03, 10, 11, 12!"
				title = "Data Entry Error"
				Msgbox.DialogType = "ERROR"
				Msgbox.Show(message, title)
				MonthEd.RequestFocus
				Return			
			End If
		End If
	End If
	
	' Day
	str1 = DayEd.Text
	If str1.Length < 1 Then
		message = "Day must be entered!"
		title = "Data Entry Error"
		Msgbox.DialogType = "ERROR"
		Msgbox.Show(message, title)
		DayEd.RequestFocus
		Return
	Else
		If str1.Length = 1 Then
			BigDte = BigDte & "0" & str1
		Else
			If str1.Length = 2 Then 
				BigDte = BigDte & str1
			Else
				message = "Day must be two digits e.g.: 01, 03, 10, 11, 12!"
				title = "Data Entry Error"
				Msgbox.DialogType = "ERROR"
				Msgbox.Show(message, title)
				MonthEd.RequestFocus
				Return		
			End If
		End If
	End If
	
	' here the BigDate is legal
	' Get the MeetDay entry
	Dim m As Map
	Qry1 = "SELECT * FROM MeetDay WHERE [BigDate] = '" & BigDte & "'"
	m = DBUtils.ExecuteMap(DM.SQL1, Qry1, Null)
	If m.IsInitialized Then
		' we have this meet
		aQMid = m.Get("qmid")

		' Put MeetDay Details into Display Panel label
		str1 = "Meetings for " &  m.Get("dayoftheweek") & ", " & m.Get("monthlong") & " " & m.Get("day")
		str1 = str1 & ", " & m.Get("year") 
		MeetDetailsLbl.Text = str1
		
		Qry2 = "SELECT VenueName, MeetingCode, RaceNo, RaceName, RaceTime, RaceDisplayStatus FROM MeetRace"
		Qry2 = Qry2 & " WHERE QMId = " & aQMid		
		
		DBUtils.LoadTVMeetings(DM.SQL1, Qry2, Null, 0, MeetDayTV, 1)	
	Else
		' no race day available
		MeetDetailsLbl.Text = ""
		MeetDayTV.Items.Clear
	End If	
End Sub

Private Sub frm_CloseRequest (EventData As Event)
	If RaceList.IsInitialized Then RaceList.Clear
	MeetDayTV.Items.Clear	
	DisplayList.Clear
	frm.Close
End Sub

Private Sub SetupTableView
	Dim RList As List
	
	RList.Initialize
	RList.Add("Venue")
	RList.Add("Code")
	RList.Add("RNO")
	RList.Add("Race Name")
	RList.Add("Time")
	RList.Add("Status")
	
	MeetDayTV.SetColumns(RList)
	
	MeetDayTV.SetColumnWidth(0,135.0)	' Venue
	MeetDayTV.SetColumnWidth(1, 50.0)	' Code	- BLUE center
	MeetDayTV.SetColumnWidth(2, 50.0)	' RNO	= center
	MeetDayTV.SetColumnWidth(3, 170.0)	' RaceName
	MeetDayTV.SetColumnWidth(4, 50.0)	' RaceTime	- center
	MeetDayTV.SetColumnWidth(5, 100.0)	' Status
	
	' do not want sorting as RowIndex is used throught the calcs
	For i= 0 To 5
		MeetDayTV.SetColumnSortable(i, False)
	Next
	
	RList.Clear
End Sub

' Resize TableView
' Take Border widths and Scroll width of Width and divide remainder by 100%
' being the total width of the Columns
' Alternat is to used fixed width for some columns and subtract it
' from the Width and divide 100% of remainder area over remainder of % columns
Sub MeetDayTV_Resize (Width As Double, Height As Double)
	Dim wd As Double
	' borders = 4, scroll = 14
	wd = (Width - 18) / 100.00
	' work % for Width
	MeetDayTV.SetColumnWidth(0, wd * 23.00)	' Venue
	MeetDayTV.SetColumnWidth(1, wd * 8.80)	' Code
	MeetDayTV.SetColumnWidth(2, wd * 8.80)	' RNO
	MeetDayTV.SetColumnWidth(3, wd * 34.80)	' RaceName
	MeetDayTV.SetColumnWidth(4, wd * 8.80)	' Time
	MeetDayTV.SetColumnWidth(5, wd * 16.00)	' Status
End Sub

Sub MonthEd_TextChanged (Old As String, New As String)
	Dim len As Int
	Dim chr1 As Char
	
	len = New.Length
	If len > 0 Then
		For i = 0 To len-1
			chr1 = New.CharAt(i)
			If "0123456789".Contains(chr1) = False Then
				len = Old.Length
				MonthEd.Text = Old
				MonthEd.SetSelection(len, len)
			End If
		Next
	Else
		MonthEd.Text = ""
	End If		
End Sub

Sub DayEd_TextChanged (Old As String, New As String)
	Dim len As Int
	Dim chr1 As Char
	
	len = New.Length
	If len > 0 Then
		For i = 0 To len-1
			chr1 = New.CharAt(i)
			If "0123456789".Contains(chr1) = False Then
				len = Old.Length
				DayEd.Text = Old
				DayEd.SetSelection(len, len)
			End If
		Next
	Else
		DayEd.Text = ""
	End If		
End Sub

Sub YearEd_TextChanged (Old As String, New As String)
	Dim len As Int
	Dim chr1 As Char
	
	len = New.Length
	If len > 0 Then
		For i = 0 To len-1
			chr1 = New.CharAt(i)
			If "0123456789".Contains(chr1) = False Then
				len = Old.Length
				YearEd.Text = Old
				YearEd.SetSelection(len, len)
			End If
		Next
	Else
		YearEd.Text = ""
	End If			
End Sub

